/*************************************************************/
/* Run this script to copy files to the target directory and */
/* create a new desktop CDRWSEL object eCS1.x                */
/*************************************************************/

/* Prerequisites for the desktop object     */
/* and this cmd file                        */
/* Load RexxUtil DLL                        */
call RxFuncAdd 'SysLoadFuncs' , RexxUtil, 'SysLoadFuncs'
call SysLoadFuncs

nfiles=""
env = 'OS2ENVIRONMENT'
Insdir = value('PROGRAMS',,env)
ossystem = Translate(value('OS',,env))
Sys_ini=Strip(value('user_ini',,env))
bootdrv = SysSearchPath('DPATH', 'OS2\INSTALL')
/* extract */ bootdrv = substr(bootdrv,1,2)
pgm_dir=Directory()

If insdir='' then insdir = Directory()
   else insdir=insdir||"\CDRWsel"

If length(Sys_ini)>2 then Sys_ini=substr(Sys_ini,1,LastPos('\',Sys_ini)-1)
   else Sys_ini=insdir 

If substr(ossystem,1,3)\="ECS" then ossystem="OS2"
   Else ossystem="ECS"

/* Set a few more variables */ 
crlf	='0d0a'x
wscare  ='db'x 
exe	='cdrwsel.exe'
Title	='CDRWSel'
dir_default = ' This is the recommended installation path : '
default = 'default'
Mkisofs2_path = ''
readini = ''
Ignored_files=0

/* Clear screen and first message's */
Call SysCls
say crlf crlf
say ' This script sets up the desktop object for '||Title
say ' Be sure you are running this from the '||Title||' directory.'||crlf crlf

say ' Press [Y] to continue or [Enter] to quit'||crlf
pull approval
if translate(approval) <> 'Y' then exit
say ''

/* Are we in the right program directory?   */
say ' Locating '||exe||'...'||crlf
TestFor=directory()||'\'||exe
If stream(TestFor, 'c', 'query size')=0 then do
   say ' Please run this program from the same directory as the '||exe||' file'||crlf
   say ' Exiting...'||crlf
   exit
end

Do until (translate(approval1)='Y')&(insdir\='')
  Call Path_selection
End

If substr(insdir,1,1) <> substr(Directory(),1,1) then substr(approval1,1,2) 
If insdir\=pgm_dir then do
   '@md 'insdir
   Call SysFileTree pgm_dir||'\*.*', 'Fcdrwsel', 'FO'
   If Fcdrwsel>0 then do
      Call SysCls
      say crlf
      say '     '||'['||copies(' ',Fcdrwsel.0)||']' 
      Do i=1 for Fcdrwsel.0
        If Translate(substr(Fcdrwsel.i,Lastpos('\',Fcdrwsel.i)+1))='CDRWSEL.IN_' then do 
           '@copy' Fcdrwsel.i Sys_ini
           '@ren ' Sys_ini'\CDRWSEL.IN_' Sys_ini'\CDRWSEL.INI'
           readini = Sys_ini||"\CDRWSEL.INI"    
        End
        If (pos('DVDDAO',Translate(Fcdrwsel.i))=0)&(pos('CDRTOOLS',Translate(Fcdrwsel.i))=0) then '@copy' Fcdrwsel.i insdir
        Else Ignored_files=Ignored_files+1
        Call SysCls
        say crlf
        say '     '||'['||copies(wscare,i)||copies(' ',Fcdrwsel.0-i)||']' 
      End
   End
End
outfile=insdir||'\INSINFO.1ST'

Call Syssleep 1
Call SysCls
say crlf crlf
say 'CDRWSel files copied...'
say 'Files no copied : 'Ignored_files'   [This counter may be equal or above 0]' 
say crlf
say 'Checking for additionnal products...'
say crlf
call SysFileTree pgm_dir||'\CDRTOOLS2*.ZIP', 'fileok', 'FO'
If fileok.0 > 0 then do 
   say fileok.1||' found.'
   say 'Suggest to install product into : '||insdir||'\CDRTOOLS'
   say '[Y] to proceed the installation or any key to bypass this install'
   Pull user_choice
   If Translate(user_choice)='Y' then do
      '@md 'insdir'\cdrtools'
      'unzip '||fileok.1||' -d '||insdir||'\cdrtools'
      Call Syssleep 1
      nfiles=Strip(nfiles)||"CDRECORD2 "||insdir||'\cdrtools'||crlf
      nfiles=Strip(nfiles)||"MKISOFS2   "||insdir||'\cdrtools'||crlf
      If readini\='' then do
         result=SysIni(readini, "CDRWSEL", "CDrecord2", insdir||'\cdrtools')
         Mkisofs2_path=insdir||'\cdrtools\'
      End
      Call SysFileSearch 'ASPIROUT', bootdrv'\CONFIG.SYS', 'filecfg.'
      If filecfg.0=0 then do
         Call SysCls
         say crlf crlf
         say '*WARNING* You must add ASPIROUT.SYS into your config.sys'
         say crlf
         say 'Read CDRTOOLS readme file' 
      End 
   End 
End
Else do
   Say crlf
   Say ' No CDRTOOLS*.ZIP package found under current directory'
   Say ' If CDRTOOLS is installed on your system :'
   Say ' Enter [dir name] e.g. "C:\PROGRAMS\CDRTOOLS" or '
   Say ' Enter [        ] blank to ignore'
   Pull user_choice
   If (user_choice\='')&(pos(':',user_choice)=2) then do
      If lastpos('\',user_choice)=length(user_choice) then user_choice=substr(user_choice,1,length(user_choice)-1)
      nfiles=Strip(nfiles)||"CDRECORD2 "||user_choice||crlf
      nfiles=Strip(nfiles)||"MKISOFS2   "||user_choice||crlf
      If readini\='' then do
         result=SysIni(readini, "CDRWSEL", "CDrecord2", user_choice)
         Mkisofs2_path=user_choice||'\'
      End
   End        
End

Call SysCls
say crlf crlf
say 'Checking for additionnal products...'
Call SysFileTree pgm_dir||'\DVDDAO*.ZIP', 'fileok', 'FO'
If fileok.0 > 0 then do 
   say fileok.1||' found.'
   say 'Suggest to install product into : '||insdir||'\DVDDAO'
   say '[Y] to proceed the installation or any key to bypass this install'
   Pull user_choice
   If Translate(user_choice)='Y' then do
      '@md 'insdir'\dvddao'
      'unzip '||fileok.1||' -d '||insdir||'\dvddao'
      Call Syssleep 1
      nfiles=Strip(nfiles)||"DVDDAO    "||insdir||'\dvddao' 
      If (readini\='')&(Mkisofs2_path\='') then do 
         Vr1='C000020053300034201101058000!0!1!1!1385!1!64!262144!3,31!1G!'
         Vr2=insdir||'\dvddao\'
         Vr3=Mkisofs2_path
         Vr4='mkisofs2.exe'
         result=SysIni(readini, "CDRWSEL", "DvDao", Vr1||Vr2||""||Vr3||""||Vr4)
      End 
   End 
End
Else do
   Say crlf
   Say ' No DVDDAO*.ZIP package found under current directory'
   Say ' If DVDDAO is installed on your system :'
   Say ' Enter [dir name] e.g. "C:\PROGRAMS\DVDDAO" or '
   Say ' Enter [        ] blank to ignore'
   Pull user_choice
   If (user_choice\='')&(pos(':',user_choice)=2) then do
      If lastpos('\',user_choice)=length(user_choice) then user_choice=substr(user_choice,1,length(user_choice)-1)
      nfiles=Strip(nfiles)||user_choice
      If (readini\='')&(Mkisofs2_path\='') then do 
         Vr1='C000020053300034201104058000!0!1!1!1385!1!64!2048!3,31!1G!'
         Vr2=user_choice||'\'
         Vr3=Mkisofs2_path
         Vr4='mkisofs2.exe'
         result=SysIni(readini, "CDRWSEL", "DvDao", Vr1||Vr2||""||Vr3||""||Vr4)
      End 
   End        
End

If nfiles\='' then Call my_rxwrite

Call SysCls
say crlf crlf
say 'Checking for rxu...'
call SysFileTree pgm_dir||'\rxu*.ZIP', 'fileok', 'FO'
If fileok.0 > 0 then do 
   say fileok.1||' found.'
   say 'Suggest to install product into : '||insdir||'\RXU'
   say 'and copy rxu.dll into '||bootdrv||'\'||ossystem||'\dll'
   say 'Please, accept. You can move rxu.dll into an other dllpath afterward'   
   say '[Y] to proceed the installation or any key to bypass this install'
   Pull user_choice
   If Translate(user_choice)='Y' then do
      '@md 'insdir'\rxu'
      'unzip '||fileok.1||' -d '||insdir||'\rxu'
      '@copy 'insdir'\rxu\rxu.dll 'insdir
      '@copy 'insdir'\rxu\rxu.dll' bootdrv'\'ossystem'\dll' 
   End
End 

Call SysCls
say crlf crlf
say 'Final step... Creating WPS icon program'

Setup   ='OBJECTID=<CDRWSel>;'||,
	 'EXENAME=' || Insdir || '\' || exe || ';' ||,
	 'STARTUPDIR=' || Insdir || ';' ||,
         'ICONFILE=' || Insdir || '\cdrwsel.ico;' ||,
         'PROGTYPE=PM;' ||,
         'PARAMETERS=-i -s -vol -sdm;' 

rc=' '
call SysCreateObject "WPProgram", Title, "<WP_DESKTOP>", Setup, 'Update'
/* Check if the WPS object was created      */
if rc = 0 then
   say 'Object creation for 'Title ' failed!  rc='||crlf
else do
   Call SysCls
   say crlf crlf
   say ' Object created for' Title||crlf
   say crlf
   say ' After installation, to change pgm path,'
   say ' move complete CDRWSel directory to new one under WPS'
   say crlf crlf
   say " If program object isn't on the desktop, empty your Trash Cam"
   say crlf crlf crlf
   say ' Verify that ASPIROUT.SYS is not "REM" in '||bootdrv||'\config.sys '    
exit

Path_selection:
/* Should we put the program under the correct path? */
Call SysCls
say crlf crlf
say dir_default
say ' ['||insdir||']'crlf crlf

say ' Press [Y] to Accept '||default||' directory, [N] to end'
say ' or new [path_name] to change '||default||crlf
pull approval1
if translate(approval1) = 'N' then exit
if translate(approval1) \= 'Y' then do 
   insdir=Translate(approval1,'\','/')
   dir_default = ' This is the selected installation path : '
   default = ''
end /* do */
say ''
return

my_rxwrite:
If Wx_pos=1 then do
     "@del "||outfile
     Call STREAM outfile,'c','open write'
     Rrc=CHAROUT(outfile,nfiles,1)
   End
   Else do
      Call STREAM outfile,'c','open write'
      Rrc=CHAROUT(outfile)
      Rrc=CHAROUT(outfile,nfiles)
End
If Rrc>0 then say outfile' used for simplify first cdrwsel start no created. RC : 'Rrc    
Call STREAM outfile,'c','close'
If (readini\='')&(Mkisofs2_path\='') then do
   Call SysCls
   say crlf
   say ' CDRWSel quick customization enabled,'
   say ' Do a "drive refresh" + "save" under Settings at first CDRWSEL run'
   say ' Running...'
   Call Syssleep 4
End
return
